    program

    !Adding some C code to your Clarion App
    !1. I downloaded and saved the RC4.h and RC4.C files
    !2. I modified the .h file to wrap the functions in  extern "C" { };
    !        or you'll get a linker due to the name mangling
    !        Example
    !               extern "C" {
    !                    void rc4_setup( struct rc4_state *s, unsigned char *key,  int length );
    !                          };
    !3. Prototyped the C functions in Clarion and made the NAME('_xxx') start with an underscore the Extern C standard
    !4. Added RAW since I would be passing strings
    !5. Since the C code is being compiled by Clarion Pascal is not needed ?
    !6. I prototyped other structures/equates in Clarion needed to pass to the C functions
    !7. I added the .C source moudle to my project

    !The biggest part was trying to figure out how to use these two functions
    !3 damn functions, here's what I figured out
    !see example below

    !Pages of interest
    !   http://www.cr0.net:8040/code/crypto/            Where the code came from
    !   http://www.l3.u-net.com/articles/art3.htm       Using C in Clarion

    include 'aes_h_inc.inc'

! EnKey               STRING('supercalifragilisticexpeealidoshish')
EnKey               String('<00h><01h><02h><03h><05h><06h><07h><08h><0Ah><0Bh><0Ch><0Dh><0Fh><010h><011h><012h>')
                           ! 00   01   02   03   05   06   07   08   0A   0B   0C   0D   0F    10    11    12   
ctx                 LIKE(aes_context)
ret     signed

encrypt_16In     STRING(16)
encrypt_16Out    STRING(16)
decrypt_16In     STRING(16)
decrypt_16Out       STRING(16)
expected            string('<0D8h><0F5h><032h><053h><082h><089h><0EFh><07Dh><06h><0B5h><06h><0A4h><0FDh><05Bh><0E9h><0C9h>')
                           !  D8    F5    32    53    82    89    EF    7D   06    B5   06    A4    FD    5B    E9    C9
a                   string('<11>')
b                   string('<0Bh>')


    CODE
    !Create the AES Context
    ret = aes_set_key(ctx, EnKey, SetKeyBits_Low )
    if ret<>0 then Message('aes_set_key failed ret=' & ret).

    ! encrypt_16In='the clarion call'
    encrypt_16In = '<050h><068h><012h><0A4h><05Fh><08h><0C8h><089h><0B9h><07Fh><059h><080h><03h><08Bh><083h><059h>'
                   ! 50     68    12    A4    5F   08    C8    89    B9    7F    59    80   03    8B    83    59
    aes_encrypt( ctx, encrypt_16In, encrypt_16Out )
    message('out: ' & encrypt_16Out & '||Expected: ' & expected)
    if encrypt_16Out = expected
        message('success!')
    ELSE
        message('failure')
    END

